#!/bin/bash
# analiza.sh - Wylicza krótkie statystyki na podstawie logów Barbelo (liczba sieci, zastosowane szyfrowanie)
# Autor: Konrad Kowalski (kowalsio.com)

if [ $1 ]
then
	ZBADANO=$(cat $1 | grep "<SSID>" | wc -l)
	W_WEP=$(cat $1 | grep "<encryption>WEP</encryption>" | wc -l)
	W_PSK=$(cat $1 | grep "<encryption>PSK</encryption>" | wc -l)
	W_WPA=$(cat $1 | grep "<encryption>WPA</encryption>" | wc -l)
	W_NONE=$(cat $1 | grep "<encryption>None</encryption>" | wc -l)
	WPA=$[$W_WPA-$W_PSK]
	PSK=$[$W_PSK-$WPA]
	WEP=$[$ZBADANO-$W_NONE-$WPA-$PSK]
	echo -e "*********************************\n\t   Statystyka\n*********************************"
	echo -e "Wykryto sieci:\t\t" $ZBADANO
	echo -e "Niezabezpieczone:\t" $W_NONE
	echo -e "WPA:\t\t\t" $WPA
	echo -e "PSK (i nowsze(WPA2..)):\t" $PSK 
	echo -e "WEP:\t\t\t" $WEP
	SPR=$[$WPA+$PSK+$W_NONE+$WEP]
	echo -e "---------------------------------"
	echo "Jeśli poniższe wartości są równe to znaczy ze statystyka jest obliczona bezbłędnie"
	echo -e "Sprawdzenie:\t\t" $SPR
	echo -e "Wykryto sieci:\t\t" $ZBADANO
else
	echo 'przy wywołaniu podaj nazwe pliku xml do analizy'
fi
